REM code from dcromley 11/16/2017
DEFINT A-Z
REM $DYNAMIC
DIM SHARED QUEENS AS INTEGER
DIM SHARED nsolutions AS DOUBLE
DIM SHARED arrayqcol(1) AS _BYTE ' columns of queens
PRINT "MIN";: INPUT MIN
PRINT "MAX";: INPUT MAX
IF MIN = 0 THEN MIN = 8
IF MAX = 0 THEN MAX = 12
PRINT "Calculating boards from"; MIN; "to"; MAX; ".."
FOR QUEENS = MIN TO MAX
    PRINT "Calculating"; QUEENS; "queens:"
    nsolutions = 0
    REDIM SHARED arrayqcol(QUEENS) AS _BYTE
    t! = TIMER
    CALL dorow(1) ' start with row 1
    PRINT STR$(nsolutions) + " solutions,";
    PRINT TIMER - t!; "seconds."
NEXT
END

SUB dorow (irow) ' starts with row irow
    FOR icol = 1 TO QUEENS
        FOR iqueen = 1 TO irow - 1 ' check for conflict with previous queens
            IF arrayqcol(iqueen) = icol THEN GOTO continue1 ' same column?
            ' iqueen is also row of queen
            IF iqueen + arrayqcol(iqueen) = irow + icol THEN GOTO continue1 ' right diagonal?
            IF iqueen - arrayqcol(iqueen) = irow - icol THEN GOTO continue1 ' left diagonal?
        NEXT iqueen
        ' at this point we can add a queen
        arrayqcol(irow) = icol ' add to array
        IF irow = QUEENS THEN ' solution?
            nsolutions = nsolutions + 1
        ELSE
            CALL dorow(irow + 1) ' recursive call to next row
        END IF
        continue1:
    NEXT icol
END SUB

